// Code generated by go-swagger; DO NOT EDIT.

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"github.com/go-openapi/errors"
	"github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	cloud "github.com/hashicorp/hcp-sdk-go/clients/cloud-shared/v1/models"
)

// HashicorpCloudPackerUpdateBuildRequest hashicorp cloud packer update build request
//
// swagger:model hashicorp.cloud.packer.UpdateBuildRequest
type HashicorpCloudPackerUpdateBuildRequest struct {

	// Unique identifier of the build that should be updated; this ID was
	// created and set by the HCP Packer registry when the build was created.
	BuildID string `json:"build_id,omitempty"`

	// HCP-specific information like project and organization ID
	Location *cloud.HashicorpCloudLocationLocation `json:"location,omitempty"`

	// Information about the build you are updating.
	Updates *HashicorpCloudPackerBuildUpdates `json:"updates,omitempty"`
}

// Validate validates this hashicorp cloud packer update build request
func (m *HashicorpCloudPackerUpdateBuildRequest) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateLocation(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateUpdates(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *HashicorpCloudPackerUpdateBuildRequest) validateLocation(formats strfmt.Registry) error {

	if swag.IsZero(m.Location) { // not required
		return nil
	}

	if m.Location != nil {
		if err := m.Location.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("location")
			}
			return err
		}
	}

	return nil
}

func (m *HashicorpCloudPackerUpdateBuildRequest) validateUpdates(formats strfmt.Registry) error {

	if swag.IsZero(m.Updates) { // not required
		return nil
	}

	if m.Updates != nil {
		if err := m.Updates.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("updates")
			}
			return err
		}
	}

	return nil
}

// MarshalBinary interface implementation
func (m *HashicorpCloudPackerUpdateBuildRequest) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *HashicorpCloudPackerUpdateBuildRequest) UnmarshalBinary(b []byte) error {
	var res HashicorpCloudPackerUpdateBuildRequest
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
